package com.hanback.sensor.accel;

import android.app.Activity;
import android.os.Bundle;
import android.widget.TextView;
import android.hardware.Sensor; 
import android.hardware.SensorEvent; 
import android.hardware.SensorEventListener ; 
import android.hardware.SensorManager; 

public class AccelTestActivity extends Activity implements SensorEventListener  { 
    private float x, y, z; 

    private SensorManager sensorManager; 
    private Sensor accelerormeterSensor; 

    TextView tvX;
    TextView tvY;
    TextView tvZ;
    
    protected void onCreate(Bundle savedInstanceState) { 
        super.onCreate(savedInstanceState); 
        sensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
        setContentView(R.layout.main);
        accelerormeterSensor = sensorManager 
                .getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
        
        tvX = (TextView)findViewById(R.id.xaxis);
        tvY = (TextView)findViewById(R.id.yaxis);
        tvZ = (TextView)findViewById(R.id.zaxis);
    } 

    @Override 
    public void onStart() { 
        super.onStart(); 
        if (accelerormeterSensor != null) 
            sensorManager.registerListener(this, accelerormeterSensor, 
                    SensorManager.SENSOR_DELAY_NORMAL); 
} 

    @Override 
    public void onStop() { 
        super.onStop(); 
        if (sensorManager != null) 
            sensorManager.unregisterListener(this); 
    } 
    @Override 
    public void onAccuracyChanged(Sensor sensor, int accuracy) { 
    } 

    @Override 
    public void onSensorChanged(SensorEvent event) { 
        if (event.sensor.getType() == Sensor.TYPE_ACCELEROMETER) { 
                x = event.values[SensorManager.DATA_X]; 
                y = event.values[SensorManager.DATA_Y]; 
                z = event.values[SensorManager.DATA_Z]; 

                tvX.setText("X:"+x);
                tvY.setText("Y:"+y);
                tvZ.setText("Z:"+z);
        } 

    }       
}

