package com.hanback.cds;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class CDSActivity extends Activity {
    /** Called when the activity is first created. */
    static { System.loadLibrary("cds"); }
	private native int getCDSValue();

	final	int		MY_SEND=101;

	private TextView	tvValue;
    private int	CDSValue;

    EventHandler	m_eventHandler;
	MyThread 		m_Thread;
	Button 			ButStart;
    
	boolean			m_bStarted;
	int				m_iCount;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        

        m_eventHandler = new EventHandler();
		m_Thread = new MyThread(); 
		m_Thread.start();        
        
        tvValue = (TextView) findViewById(R.id.CDSValue);
        
        m_bStarted = false;
        m_iCount = 0;
        
        ButStart = (Button)findViewById(R.id.ButStart);      
        ButStart.setOnClickListener(new Button.OnClickListener() {
        	public void onClick(View v) {
        		if(m_bStarted) {
        			m_bStarted = false;
	        		ButStart.setText("Start");
        		} else {
        			m_bStarted = true;
	        		ButStart.setText("Stop");
        		}
        		tvValue.setText("");
        		m_iCount = 0;
        	}        	
        });		        
    }
	  
    @Override
    public void onDestroy() {
        m_bStarted = false;
		ButStart.setText("Start");
    	super.onDestroy();
    }

    @Override
    public void onResume() {
    	m_bStarted = false;
		ButStart.setText("Start");
    	super.onResume();
    }

    @Override
    public void onPause() {
        m_bStarted = false;
		ButStart.setText("Start");
        super.onPause();
    }
    

    public void OutputCDSValue(int value)
    {
		if(m_iCount == 10){
			m_iCount = 0;
			tvValue.setText("CDSValue = "+value);
		} else {
			String tmpStr = new String(tvValue.getText().toString()+"\n");
			tmpStr += new String("CDSValue = "+value);
			
			tvValue.setText(tmpStr);
			m_iCount++;
		}
    }
	
    ////////////////////////////////////////
    //   ޼ ڵ鷯 Ŭ
    /////////////////////////////////////////
  	public class EventHandler extends Handler 
  	{
  		EventHandler() {}    	  
  		public void handleMessage(Message msg) 
  		{
  			try
  			{
  	    		if(msg.what == MY_SEND)
  	    		{
	        		CDSValue = getCDSValue();
        			OutputCDSValue(CDSValue);
  	    		}
  			}
  			catch(Exception e) {}
  		    		
  			return;
  		}
  	}		
       

  	class MyThread extends Thread
	{
      public void run()
      {
      	try
      	{
      		while(true)
      		{      		
      			if(m_bStarted)
      			{
    				Message msg1 = m_eventHandler.obtainMessage();
    				msg1.what= MY_SEND;
    				m_eventHandler.sendMessage(msg1);
      			}
      			Thread.sleep(100); // 100ms
      		}
      	}
          catch (Exception e) 
          {
//          	System.out.println(e);
          }
      }// end of run         
	} // end of myThread	 
}