package com.hanback.zigbee;

import java.util.Formatter;

import com.JavaComm.JavaComm;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.TextView;

public class ZigbeeTest extends Activity {
    /** Called when the activity is first created. */
	final 	int 	COMM_RECV=102;
	final	char	Sync = 0x7E;
	final	char	Dummy=0x7D;

    boolean	isConnected = false;
	JavaComm		m_comm;		// ſ  ü
    EventHandler	m_eventHandler;
	int		m_fd;
		
    // Receive Data
	char		RecvData[];
	int			RcvLength;

	int			RcvTmpLength;
	char		RecvTmp[];

    EditText 	edtPort;  
	// Log
    TextView	tvLog;
	int			tvLogCount;
	
	Button 		ButConnect;
    private RadioGroup RGBoard;
    private int	RadioID;
    String		Port;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        m_eventHandler = new EventHandler();
        
		m_comm = new JavaComm(m_eventHandler, 1024);
		m_comm.start();
        
		isConnected = false;
		
		// Receive Data
        RecvData = new char[1024];
        RecvTmp = new char[1024];
        
//        edtPort  = (EditText)findViewById(R.id.port);
        RGBoard = (RadioGroup) findViewById(R.id.RGBoard);
    	        
     	// Log      	
		tvLog = (TextView)findViewById(R.id.log);
		tvLog.setText("");
		tvLogCount = 0;
        
 		
		
		ButConnect = (Button) findViewById(R.id.Connect);
		ButConnect.setOnClickListener(new Button.OnClickListener() {
			public void onClick(View v) {
				//  Է  ޾ƿ
				if(isConnected)
				{
					m_fd = m_comm.closePort();
					isConnected = false;
			    	ButConnect.setText("Start");
				} else {
					RadioID = RGBoard.getCheckedRadioButtonId();
		            switch(RadioID)
		            {
		            case R.id.ButEMPOS3 : // EMPOS3
		            	Port = new String("/dev/ttyS3");
		        		break;
		            case R.id.ButSM3_1 : // SM3 M1 Module 1.1
		            	Port = new String("/dev/s3c2410_serial2");
		        		break;
		            case R.id.ButSM3_2 : // SM3 M1 Module 1.2
		            	Port = new String("/dev/s3c2410_serial1");
		        		break;
		            }
							
					m_fd = m_comm.openPort(Port,57600,1,42);
					if(m_fd > 0)
					{
				    	isConnected = true;
				    	ButConnect.setText("Stop");
					}
				}
				OutputLogWindow(" m_fd = " + m_fd);	
			}
		});    
		
    }

	  
    @Override
    public void onDestroy() {
    	m_comm.closePort();
    	m_fd = 0;
    	isConnected = false;
    	super.onDestroy();
    }

    @Override
    public void onResume() {
    	super.onResume();
//    	if(isConnected)
//    	{
//			m_fd = m_comm.openPort(Port,57600,1,1);
//			if(m_fd > 0)
//			{
//		    	isConnected = true;
//			}
//    	}
    }

    @Override
    public void onPause() {
    	if(isConnected)
    	{
    		m_comm.closePort();
    		m_fd = 0;
	    	isConnected = false;
    	}
        super.onPause();
    }
       
    
	/////////////////////////////////////////////////
	///// Log Output
	/////////////////////////////////////////////
    public void OutputLogWindow(String buf)
    {
		if(tvLogCount == 6){
			tvLogCount = 0;
			tvLog.setText(buf);
		} else {
			String tmpStr = new String(tvLog.getText().toString()+"\n");
			tmpStr += new String(buf);
			
			tvLog.setText(tmpStr);
			tvLogCount++;
		}
    }
    
	public void OutputRcvData()
	{
		String str;
		str = new String("--> ");
		if(RcvLength > 0) 			
		{
			for(int i=0;i<RcvLength;i++)
			{	
				Formatter f = new Formatter();
				char value = RecvData[i];
				f.format("%02x ", (int)value);
				str += new String(f.toString());
			}
			OutputLogWindow(str);
			
		} else {
			OutputLogWindow("No Data Received");
		}
	}    
	 
	public void ProcessRcvData()
	{
		int i,pos;
		boolean bStarted;
		char lastCh;
			
		bStarted = false;
		pos = 0;
		lastCh = 0;
		for(i=0;i<RcvTmpLength;i++)
		{
			if(!bStarted) {
				if(RecvTmp[i] == Sync) bStarted = true;
				RecvData[pos++] = RecvTmp[i];
				continue;
			}
			if(bStarted)
			{
				if(lastCh == Dummy)
				{
					RecvData[pos++] = (char)(RecvTmp[i]^0x20);
				} else if(RecvTmp[i] == Dummy){
					// do Nothing
				} else {
					RecvData[pos++] = RecvTmp[i];
					if(RecvTmp[i] == Sync){ // Packet End
						RcvLength = pos;
						OutputRcvData();
						
						lastCh = 0;
						pos = 0;
						bStarted = false;
						continue;
					}
				}
			}
			lastCh = RecvTmp[i];
		}
	}
    		
    ////////////////////////////////////////
    //   ޼ ڵ鷯 Ŭ
    /////////////////////////////////////////
  	public class EventHandler extends Handler 
  	{
  		EventHandler() {}    	  
  		public void handleMessage(Message msg) 
  		{
  			try
  			{
  	    		if(msg.what == COMM_RECV)
  	    		{
  					RcvTmpLength = m_comm.recvbin(RecvTmp);
  					ProcessRcvData();
  	    		}
  			}
  			catch(Exception e) {}
  		    		
  			return;
  		}
  	}		
        
}