/*
 * Dipsw Device Driver
 *  Hanback Electronics Co.,ltd
 * File : dipsw.c
 * Date : April,2009
 */ 

//   
#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/errno.h>
#include <linux/types.h>
#include <asm/fcntl.h>
#include <linux/ioport.h>

#include <asm/ioctl.h>
#include <asm/uaccess.h>
#include <asm/io.h>

#define DRIVER_AUTHOR           "hanback"	//  
#define DRIVER_DESC		"dipsw program" // ⿡  

#define	DIP_MAJOR_NUMBER	246		// ̽ ֹȣ
#define	DIP_NAME		"DIPSW"		// ̽ ̸
#define DIP_MODULE_VERSION	"DIPSW V0.1"	// ̽ 

#define ADDR_DIP_PHY		0x88000060	// dipsw ּ
#define DIP_ADDRESS_RANGE	0x1000		// I/O  ũ
#define TIMER_INTERVAL		20

//Global variable
static unsigned int dipsw_usage = 0;
static unsigned long  dipsw_ioremap;
static unsigned short *dipaddr, *dipaddr1;
static unsigned short value[4];

// define functions...
//  α׷ ̽ ó ϴ 츦 óϴ Լ
int dipsw_open (struct inode *inode, struct file *filp)
{
	// ̽  ִ Ȯ.
	if(dipsw_usage != 0) return -EBUSY;

	// dipsw  ּ 
	dipsw_ioremap = (unsigned long)ioremap(ADDR_DIP_PHY, DIP_ADDRESS_RANGE);

	//   ִ I/O  Ȯ
	if(!check_mem_region(dipsw_ioremap,DIP_ADDRESS_RANGE)) {
		// I/O ޸  
		request_mem_region(dipsw_ioremap, DIP_ADDRESS_RANGE, DIP_NAME);
	}
	else	printk("driver : unable to register this!\n");
	
	// dipsw  ù°ٰ ι°ٿ  ּ 
	dipaddr =(unsigned short*)dipsw_ioremap;
	dipaddr1 =(unsigned short*)(dipsw_ioremap+0x2);
	
	dipsw_usage = 1;
	return 0;
}

//  α׷ ̽ ̻  ʾƼ ݱ⸦ ϴ Լ
int dipsw_release (struct inode *inode, struct file *filp)
{
	// ε ּҸ 
	iounmap((unsigned long*)dipsw_ioremap);

	// ϵ I/O ޸  
	release_mem_region(dipsw_ioremap, DIP_ADDRESS_RANGE);
	dipsw_usage = 0;
	return 0;
}

// ̽ ̹ б⸦ ϴ Լ
ssize_t dipsw_read(struct file *inode, char *gdata, size_t length, loff_t *off_what)
{
	int ret,i;
	short temp;

	temp = *(dipaddr1);

	value[0] = (temp)&0xff;
	value[1] = (temp >> 8)&0xff;

	// value Ű Ŀ ޸ ͸ gdata Ű 
	// ޸ Ϳ n Ʈ ŭ ִ´.
	ret=copy_to_user(gdata,value,4);
	if(ret<0) return -1;

	return length;
}

//  ۷̼ ü
//   open() Ѵ. open() ý  ȣϿ Ŀ η .
// ش ý ݰ õ   ü  open شϴ ʵ尡 ̹ 
// dipsw_open() ǵǾ Ƿ dipsw_open() ȣȴ.
// write, read, release  Ѵ.
struct file_operations dipsw_fops = 
{
	.owner		= THIS_MODULE,
	.open		= dipsw_open,
	.read		= dipsw_read,
	.release	= dipsw_release,
};

//  Ŀ η 
//  α׷ ٽ  Ŀ η  񽺸 ޴ ̹Ƿ
// Ŀ η  init()  Ѵ.
//  α׷ ҽ ο ǵ   Լ Ѵ. װ ܺ
// ̺귯   ũǾ Ǳ ̴.  α׷ Ŀ
// ϰ ũǱ  Ŀο ϰ ϴ Լ   ִ.
int dipsw_init(void)
{
	int result;

	//  ̽ ̹ Ѵ.
	result = register_chrdev(DIP_MAJOR_NUMBER, DIP_NAME, &dipsw_fops);
	if (result < 0) {  // Ͻ
		printk(KERN_WARNING"Can't get any major\n");
		return result;
	}
	
	// major ȣ Ѵ.
	printk("Init Module, Dipsw Major Number : %d\n", DIP_MAJOR_NUMBER);
	return 0;
}

//  Ŀο 	
void dipsw_exit(void)
{
	//  ̽ ̹ Ѵ.
	unregister_chrdev(DIP_MAJOR_NUMBER,DIP_NAME);

	printk("driver: %s DRIVER EXIT\n", DIP_NAME);
}

module_init(dipsw_init);	//    ȣǴ Լ
module_exit(dipsw_exit);	//    ȣǴ Լ

MODULE_AUTHOR(DRIVER_AUTHOR);	//  
MODULE_DESCRIPTION(DRIVER_DESC); // ⿡  
MODULE_LICENSE("Dual BSD/GPL");	 //  ̼ 

