/*
 * 8bit-LED Device Driver
 *  Hanback Electronics Co.,ltd
 * File : baseled.c
 * Date : October,2010
 */ 

//   
#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <asm/uaccess.h>
#include <linux/fs.h>
#include <asm/io.h>
#include <mach/regs-gpio.h>
#include <mach/gpio-bank.h>

#define DRIVER_AUTHOR			"hanback"		//  
#define DRIVER_DESC			"base led test program"	// ⿡  

#define BASELED_MAJOR   		247		// ̽ ֹȣ
#define BASELED_NAME    		"BASE LED"	// ̽ ̸
#define BASELED_MODULE_VERSION		"BASE LED V0.1"	// ̽ 

#define GPJ0CON         (*(unsigned long *)S5PV210_GPJ0CON)
#define GPJ0DAT         (*(unsigned long *)S5PV210_GPJ0DAT)
#define GPJ0PUD         (*(unsigned long *)S5PV210_GPJ0PUD)



//Global variable
static int baseled_usage = 0;		// ̹ 뿩θ Ȯϴ 

// define functions...
int baseled_open(struct inode *minode, struct file *mfile) 
{
	if(baseled_usage != 0) return -EBUSY;
	
        GPJ0CON &= (~0xFFFFFFFF);       GPJ0CON |= 0x11111111;
        GPJ0PUD &= (~0x0000FFFF);       GPJ0PUD |= 0x00005555;
        GPJ0DAT &= (~0x000000FF);       GPJ0DAT |= 0x00000000;


	baseled_usage = 1;
	return 0;
}

int baseled_release(struct inode *minode, struct file *mfile) 
{	
	baseled_usage = 0;
	return 0;
}

ssize_t baseled_write_byte(struct file *inode, const char *gdata, size_t length, loff_t *off_what) 
{
	unsigned char  c,t;
	int i;

	// gdata   ޸𸮿 c о´.
	get_user(c,gdata); 
	
	t = 0;
	for(i=0;i<8;i++)
	{
	    t <<= 1;
	    if((c >> i) & 1) t += 1;
	}
	GPJ0DAT = (unsigned int)((t)&0xff);
	
	return length;
}

static struct file_operations baseled_fops = {
	.owner		= THIS_MODULE, 
	.open		= baseled_open,
	.write		= baseled_write_byte,
	.release	= baseled_release,
};

int baseled_init(void) {
	
	int result;

	result = register_chrdev(BASELED_MAJOR,BASELED_NAME,&baseled_fops);
	
	if(result < 0) { // Ͻ
		printk(KERN_WARNING"Can't get any major\n");
		return result;
	}
	
	// major ȣ Ѵ.
	printk(KERN_INFO"Init Module, baseled Major Number : %d\n",BASELED_MAJOR);
	return 0;
}

//  Ŀο 
void baseled_exit(void) 
{
	//  ̽ ̹ Ѵ.
	unregister_chrdev(BASELED_MAJOR,BASELED_NAME);

	printk(KERN_INFO"driver: %s DRIVER EXIT\n", BASELED_NAME);
}


module_init(baseled_init);	//    ȣǴ Լ
module_exit(baseled_exit);	//    ȣǴ Լ

MODULE_AUTHOR(DRIVER_AUTHOR);	//  
MODULE_DESCRIPTION(DRIVER_DESC); // ⿡  
MODULE_LICENSE("Dual BSD/GPL");	 //  ̼ 
