#include <jni.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <termios.h>
#include <pthread.h>
#include <sys/stat.h>


int Java_com_JavaComm_JavaComm_open( JNIEnv* env, jobject jobj, jstring strDev, jstring strBaud, jint vtime, jint vmin) 
{
	char * strDevPath = 0;			// input
	unsigned int nBaudrate = 0;		// input
	int Fd = 0;						// output
	struct termios newtio;

	strDevPath= (char *)(*env)->GetStringUTFChars(env,strDev,0);	
	sscanf( (*env)->GetStringUTFChars(env,strBaud,0), "%u", &nBaudrate);

	
	Fd= open(strDevPath, O_RDWR | O_NOCTTY);			
	if (Fd <0) { perror(strDevPath); return -1; }

	
	switch(nBaudrate)
	{
		case 110:		nBaudrate= B110;	break;
		case 134:		nBaudrate= B134;	break;
		case 150:		nBaudrate= B150;	break;
		case 200:		nBaudrate= B200;	break;
		case 300:		nBaudrate= B300;	break;
		case 600:		nBaudrate= B600;	break;
		case 1200:		nBaudrate= B1200;	break;
		case 1800:		nBaudrate= B1800;	break;
		case 2400:		nBaudrate= B2400;	break;
		case 4800:		nBaudrate= B4800;	break;
		case 9600:		nBaudrate= B9600;	break;
		case 19200:		nBaudrate= B19200;	break;
		case 38400:		nBaudrate= B38400;	break;
		case 57600:		nBaudrate= B57600;	break;
		case 115200:	nBaudrate= B115200; break;
		case 230400:	nBaudrate= B230400; break;
		case 460800:	nBaudrate= B460800; break;
		case 500000:	nBaudrate= B500000; break;
		case 576000:	nBaudrate= B576000; break;
		case 921600:	nBaudrate= B921600; break;
		default: close(Fd); return -2;
	}

	bzero(&newtio, sizeof(newtio)); /* clear struct for new port settings */
	newtio.c_cflag = nBaudrate |  CS8 | CLOCAL | CREAD;
	newtio.c_iflag = IGNPAR | ICRNL;
	newtio.c_oflag = 0;
	newtio.c_lflag = ~(ICANON | ECHO | ECHOE | ISIG);

	newtio.c_cc[VINTR]    = 0;     /* Ctrl-c */
	newtio.c_cc[VQUIT]    = 0;     /* Ctrl-\ */
	newtio.c_cc[VERASE]   = 0;     /* del */
	newtio.c_cc[VKILL]    = 0;     /* @ */
	newtio.c_cc[VEOF]     = 4;     /* Ctrl-d */
//	newtio.c_cc[VTIME]    = 1;     /* inter-character timer unused */
//	newtio.c_cc[VMIN]     = 1;     /* blocking read until 1 character arrives */
	newtio.c_cc[VTIME]    = vtime;     /* inter-character timer unused */
	newtio.c_cc[VMIN]     = vmin;     /* blocking read until 1 character arrives */
	newtio.c_cc[VSWTC]    = 0;     /* '\0' */
	newtio.c_cc[VSTART]   = 0;     /* Ctrl-q */
	newtio.c_cc[VSTOP]    = 0;     /* Ctrl-s */
	newtio.c_cc[VSUSP]    = 0;     /* Ctrl-z */
	newtio.c_cc[VEOL]     = 0;     /* '\0' */
	newtio.c_cc[VREPRINT] = 0;     /* Ctrl-r */
	newtio.c_cc[VDISCARD] = 0;     /* Ctrl-u */
	newtio.c_cc[VWERASE]  = 0;     /* Ctrl-w */
	newtio.c_cc[VLNEXT]   = 0;     /* Ctrl-v */
	newtio.c_cc[VEOL2]    = 0;     /* '\0' */

	tcflush(Fd, TCIFLUSH);
	tcsetattr(Fd, TCSANOW, &newtio);

	return Fd;
}


int Java_com_JavaComm_JavaComm_close( JNIEnv* env, jobject jobj, jint nFd) 
{
	return close(nFd);
}


jstring Java_com_JavaComm_JavaComm_read( JNIEnv* env, jobject jobj, jint nFd, jint nMaxReadBytes) 
{
	char	strRecv[3000]="";			// output
	int		len=0;
	
	// : ִ 3000Ʈ ̸, NULL  Ұ(Java ڿ· ȯ)
	len= read(nFd,strRecv,nMaxReadBytes); 
	strRecv[len]='\0'; // ڿ · ޵Ǳ   NULL 
	return (*env)->NewStringUTF(env, strRecv);
}


int Java_com_JavaComm_JavaComm_write(JNIEnv* env, jobject jobj, jint nFd, jstring str1, jint nSendBytes) 
{
	char * strSend = (char *)(*env)->GetStringUTFChars(env,str1,0);

	strSend[nSendBytes]='\0';

	return write(nFd, strSend, nSendBytes);
}

int Java_com_JavaComm_JavaComm_readbin( JNIEnv* env, jobject jobj, jint nFd, jcharArray rcvdata, jint nMaxReadBytes) 
{
	unsigned char	Recv[256];			// output
	int		len=0,i;
	jchar	*data;
	
	len= read(nFd,Recv,nMaxReadBytes); 
	data =(jchar *) (*env)->GetCharArrayElements(env, rcvdata, 0) ;
	
	for(i = 0; i<len; i++) {
		data[i] = (jchar)Recv[i];	
	}
	
	(*env)->ReleaseCharArrayElements(env, rcvdata , data,  0) ;
	
	return len;
}


int Java_com_JavaComm_JavaComm_writebin(JNIEnv* env, jobject jobj, jint nFd, jcharArray snddata, jint nSendBytes) 
{
	unsigned char	Send[256];			// output
	jchar * data = (jchar *)(*env)->GetCharArrayElements(env,snddata,0);
	int i,len;

	for(i=0;i<nSendBytes;i++)
	{
		Send[i] = (char)data[i];
	}
	len = write(nFd, Send, nSendBytes);
	(*env)->ReleaseCharArrayElements(env, snddata , data,  0) ;
	return len;
}

int Java_com_JavaComm_JavaComm_isInput( JNIEnv* env, jobject jobj, jint nFd )
{
	fd_set readfs;
	int sel;
	struct timeval timeout;

	FD_ZERO(&readfs);

	timeout.tv_sec = 0;
	timeout.tv_usec = 5000;

	FD_SET(nFd, &readfs);

	sel = select(nFd + 1, &readfs, NULL, NULL, &timeout);

	if (sel > 0 && FD_ISSET(nFd,&readfs) ) 
	{
		return 1;
	}

	return 0;
}


